﻿using System.Runtime.InteropServices;
using System.Security.Cryptography.X509Certificates;

namespace Kompozyt
{
    internal class Program
    {
        class OdwiedzającyWyświetlającyInformacje : IOdwiedzający
        {
            public void Odwiedź(IPracownik pracownik) //zadanie domowe: przesłać głębokość -> wcięcia
            {
                Console.WriteLine(pracownik.ToString());
            }
        };

        class OdwiedzającyZliczający : IOdwiedzający
        {
            public int Licznik { get; private set; }

            public void Odwiedź(IPracownik pracownik)
            {
                Licznik++;
            }
        }

        class OdwiedzającySpłaszczający : IOdwiedzający
        {
            private List<IPracownik> lista = new List<IPracownik>();

            public void Odwiedź(IPracownik pracownik)
            {
                lista.Add(pracownik);
            }

            public IPracownik[] TablicaPracowników
            {
                get
                {
                    return lista.ToArray();
                }
            }
        }

        static void Main(string[] args)
        {
            Kierownik rektor = new Kierownik("Andrzej", "Tretyn", "rektor");
            Pracownik prorektor = new Pracownik("Joanna", "Kucharzewska", "prorektor ds współpracy z otoczeniem gospodarczym");
            Kierownik dziekanWFAiIS = new Kierownik("Winicjusz", "Drozdowski", "dziekan");
            Kierownik kierownikKatedry = new Kierownik("Alicja", "Chruścińska", "kierownik katedry");
            Kierownik prodziekanStudenci = new Kierownik("Anna", "Bartkiewicz", "prodziekan ds. studentów");
            Pracownik pracownik = new Pracownik("Agnieszka", "Marasek", "laborant, planista");
            Kierownik prodziekanFinanse = new Kierownik("Beata", "Derkowska", "prodziekan ds. finansów");

            rektor.DodajPodwładnych(prorektor);
            rektor.DodajPodwładnych(dziekanWFAiIS);
            dziekanWFAiIS.DodajPodwładnych(prodziekanStudenci);
            dziekanWFAiIS.DodajPodwładnych(prodziekanFinanse);
            dziekanWFAiIS.DodajPodwładnych(kierownikKatedry);
            kierownikKatedry.DodajPodwładnych(dziekanWFAiIS); //cykl
            kierownikKatedry.DodajPodwładnych(pracownik);

            Console.WriteLine("\n1");
            IOdwiedzający odwiedzający1 = new OdwiedzającyWyświetlającyInformacje();
            rektor.PrzyjmijWizytę(odwiedzający1);

            Console.WriteLine("\n2");
            OdwiedzającyZliczający odwiedzający2 = new OdwiedzającyZliczający();
            rektor.PrzyjmijWizytę(odwiedzający2);
            Console.WriteLine($"Liczba elementów: {odwiedzający2.Licznik}");

            Console.WriteLine("\n3");
            OdwiedzającySpłaszczający odwiedzający3 = new OdwiedzającySpłaszczający();
            rektor.PrzyjmijWizytę(odwiedzający3);
            Console.WriteLine("Liczba elementów w tablicy: " + odwiedzający3.TablicaPracowników.Length);
            foreach(IPracownik pracownik3 in odwiedzający3.TablicaPracowników)
            {
                Console.WriteLine(pracownik3.ToString());
            }

            Console.WriteLine("\n4");
            List<IPracownik> tablica4 = rektor.ToList();
            Console.WriteLine("Liczba elementów w tablicy: " + tablica4);
            foreach (IPracownik pracownik3 in tablica4)
            {
                Console.WriteLine(pracownik3.ToString());
            }

            Console.WriteLine("\n5");
            foreach (IPracownik podwładny in rektor)
            {
                Console.WriteLine(podwładny.ToString());
            }
            Console.WriteLine(rektor.Count());
            var zapytanie = from IPracownik pracownik5 in rektor                            
                            select pracownik5.ToString();
            Console.WriteLine(zapytanie.Count());
        }
    }
}
